/* atcprecv.c */

/* Demonstates the use of recvfrom for datagram transfer */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <errno.h>
#include <signal.h>
#include <sys/time.h>

static struct timezone dummy = {0,0};
static double tu1;
static double tu2;
static int    frames = 0;
static int    drops = 0;
static int    dropcount = 0;
char buf[16 * 1024];

void sigintr(
int  dummy)
{
   printf("Frames recvd = %10d \n", frames);
   exit(1);
}

void aip_recv(
int s)                  /* socket handle */
{
   int rc;
   int amt = 0;
   int status;

   signal(SIGINT, sigintr);

   status = read(s, buf, sizeof(buf));
   while (status >  0)
   {
      amt += status;
   /* write(1, buf, status); */
      status = read(s, buf, sizeof(buf));
      frames += 1;
   }
   printf("Final return code was %d \n", rc);
   printf("Final errno was       %d \n", errno);

   printf("Receiver complete.. received %d bytes \n", amt);
}

struct sockaddr_in name;
struct sockaddr_in sname;
int namelen;

char hnamebuf[80];

main(
int argc,
char** argv)
{
   int i, me, you;
   unsigned char c;
   int sock;
   int netaddr;
   int status;
   unsigned dummy;
   int msgcount;
   int msgsock;
   int namesize;
   struct hostent *hp;


/* Create TCP socket */

   sock = socket(PF_INET, SOCK_STREAM, 0);
   if (sock < 0)
   {
      printf("Socket create failed \n");
      exit(1);
   }

   dummy = 0;
   bcopy((char *)&dummy, (char *)&name.sin_addr, sizeof(dummy));

/* Fill in protocol family and port # from command line then */
/* bind the socket to the specified address.                 */

   name.sin_family = AF_INET;
   if (argc > 1)
      name.sin_port = htons(atoi(argv[1]));
   else
      name.sin_port = htons(33456);

   status = bind(sock, (struct sockaddr *)&name, sizeof(name));
   printf("Bind to port %d status is %d\n",
                       ntohs(name.sin_port),  status);

   if (status < 0)
   {
     perror("bind error");
     exit(1);
   }

   status = listen(sock, 4);
   if (status < 0)
   {
     printf("Listen failed with code %d. \n", errno);
     exit(4);
   }

nextsession:
   status = accept(sock, (struct sockaddr *)&name, &namesize);
   if (status < 0)
   {
      printf("Accept  failed with code %d. \n", errno);
      exit(5);
   }

   msgsock = status;

/* Wait for someone to send me a datagram */

   aip_recv(msgsock);
   goto nextsession;
}
