/* atmtest3.c */

/* This program writes one register in the SAP reg set  */

#include <stdio.h>
#include <fcntl.h>

#include "atmuser.h"

int iobuf[1024];

void main(
int argc,
char **argv)
{
   int fd;
   int regid;

   fd = open("/dev/ape25", O_RDWR);

   if (fd < 0)
   {
      printf("Device /dev/ape25 could not be opened.  \n");
      exit(1);
   }

   if (argc < 3)
   {
      printf("This program writes one SAP set register \n");
      printf("Usage is:  atmtest3  regid value (in hex)  \n");
      exit(1);
   }

   sscanf(argv[1], "%x", iobuf + 0);     /* Id of reg to write */
   sscanf(argv[2], "%x", iobuf + 1);     /* value to be written*/

   ioctl(fd, AIO_WTSREG, iobuf);

   ioctl(fd, AIO_RDSREG, iobuf);

   printf("Value of SAP reg %x is %x \n", iobuf[0], iobuf[1]);
}

