/* atmtest5.c */

/* This program reads an arbitrary address in */
/* local memory via the SAP registers.        */

#include <stdio.h>
#include <fcntl.h>

#include "atmuser.h"

int iobuf[1024];

void main(
int argc,
char **argv)
{
   int fd;
   int regid;

   fd = open("/dev/ape25", O_RDWR);
   if (fd < 0)
   {
      printf("Device /dev/ape25 could not be opened.  \n");
      exit(1);
   }

   if (argc < 2)
   {
      printf("This program reads one local memory word via the SAP\n");
      printf("You must supply the word's address in hex as parm 1.  \n");
      exit(1);
   }

   sscanf(argv[1], "%x", iobuf + 0);     /* Id of reg to read */

   ioctl(fd, AIO_RDVSAP, iobuf);
   printf("Value of local address %x is %x \n", iobuf[0], iobuf[1]);
}

