/* atmuser.h */

/* IOCTL codes */

#define AIO_RDCREG     10              /* Read one of the control regs */
#define AIO_WTCREG     11

#define AIO_RDSREG     12              /* Read one of the SAP regs.    */
#define AIO_WTSREG     13

#define AIO_MAPDMA     14

#define AIO_RDVSAP     15              /* Read ape25 address space     */
#define AIO_WTVSAP     16              /* .. via the SAP regs.         */

#define AIO_SEND       17              /* Generate a test message.     */

#define AIO_CREATELC   18
#define AIO_FREELC     19

#define AIO_SENDDATA   20
#define AIO_RECVDATA   21

#define AIO_RECVBUF    22             /* Define a receiver buffer pool */

#define AIO_GETPMD     23             /* Get performance stats.        */
#define AIO_GETLOGB    24
#define AIO_GETXLOGB   25

#define AIO_DUMPRFL    33

#define AIO_RDNVRAM    41
#define AIO_WTNVRAM    42

#define AIO_SETQMAX       50
#define AIO_SETDROPTHRESH 51

struct dmatype
{
   unsigned int phys_base;
   unsigned int *virt_base;
   unsigned int *kbase;
};

/* These offsets must match the structure defined below */

#define RBO_BASE        0
#define RBO_IN          1
#define RBO_OUT         2
#define RBO_LEN         3
#define RBO_FREE        4
#define RBO_DATA        5

struct ubuftype
{
   unsigned char *base;                /* Buffer location      */
   unsigned char *in;                  /* Next input slot      */
   unsigned char *out;                 /* Next output slot     */
   int            len;                 /* Buffer length.       */
   int            free;                /* Number of free bytes */
   int            data;                /* Number of data bytes */
};


