/* aiprecv.c */

/* Demonstates the use of recvfrom for datagram transfer */


#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <errno.h>

char buf[16 * 1024];
struct sockaddr_in name;
struct sockaddr_in sname;
int namelen;

char hnamebuf[80];

main(
int argc,
char** argv)
{
   int i, me, you;
   unsigned char c;
   int sock;
   int netaddr;
   int status;
   unsigned dummy;
   int msgcount;


/* Create datagram socket */

   sock = socket(PF_INET, SOCK_DGRAM, 0);
   if (sock < 0)
   {
      printf("Socket create failed \n");
      exit(1);
   }

/* Fill in protocol family and port # from command line then */
/* bind the socket to the specified address.                 */

   name.sin_family = AF_INET;
   name.sin_port = htons(33456);

   status = bind(sock, (struct sockaddr *)&name, sizeof(name));
   printf("Bind status = %d\n", status);
   if (status < 0)
   {
     perror("bind error");
     exit(1);
   }

/* Wait for someone to send me a datagram */

   namelen = sizeof(struct sockaddr_in);

   while (1)
   {
     status = recvfrom(sock, buf, sizeof(buf), 0,
                      (struct sockaddr *)&sname, &namelen);

     if (status > 0)
        write(1, buf, status);
   }

}
